'  
'   Rebex Sample Code License
' 
'   Copyright 2026, REBEX CR s.r.o.
'   All rights reserved.
'   https://www.rebex.net/
' 
'   Permission to use, copy, modify, and/or distribute this software for any
'   purpose with or without fee is hereby granted.
' 
'   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
'   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
'   OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
'   NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
'   HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
'   WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
'   FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
'   OTHER DEALINGS IN THE SOFTWARE.
' 

Imports System.IO
Imports Rebex.TerminalEmulation


''' <summary>
''' Hold configuration settings.
''' </summary>
Public Class Settings
    Inherits Configuration

    ''' <summary>
    ''' Path to the config file at Local application data storage.
    ''' </summary>
    Private Shared ReadOnly _configFile As String = Path.Combine(Environment.GetFolderPath(System.Environment.SpecialFolder.LocalApplicationData), String.Format("Rebex{0}TerminalEmulation{0}WinFormClient.xml", Path.DirectorySeparatorChar))

    Private Sub New()
        MyBase.New(_configFile)
    End Sub

    Private Shared ReadOnly _default As New Settings

    ''' <summary>
    ''' Returns the default instance.
    ''' </summary>
    Public Shared ReadOnly Property [Default]() As Settings
        Get
            Return _default
        End Get
    End Property

    Public ReadOnly Property TerminalOptions() As TerminalOptions
        Get
            Dim options As TerminalOptions = CType(GetValue("options", GetType(TerminalOptions)), TerminalOptions)

            If options Is Nothing Then
                options = New TerminalOptions
                options.Encoding = System.Text.Encoding.UTF8
            End If

            Return options
        End Get
    End Property
End Class